<!DOCTYPE html>
<html>
    <head>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width">
        <script src="https://d3js.org/d3.v3.js"></script>
        <style>
			
			
			html, body {
			  height: 100%;
			  margin: 0;
			  padding: 0;
			}
			
			g.group0 circle {
				fill: red;
			}
			
			g.group1 circle {
				fill: blue;
			}
			
			g.group2 circle {
				fill: orange;
			}
		
			g.group3 circle {
				fill: purple;
			}
		
			g.group4 circle {
				fill: aqua;
			}
		
			g.group5 circle {
				fill: brown;
			}
		
			g.group6 circle {
				fill: green;
			}
		
			g.group7 circle {
				fill: darksalmon;
			}	
		
			g.group8 circle {
				fill: fuchsia;
			}
		
			g.group9 circle {
				fill: gold;
			}
		
			g.group10 circle {
				fill: greenyellow;
			}

            g.group11 circle {
				fill: red;
			}

            g.group12 circle {
				fill: teal;
			}

            g.group13 circle {
				fill: darkslateblue;
			}

			
			
			
		</style>
		
        <title>D3 2</title>
    </head>
    <body>
        <script>
            var data = [
                {x:10,y:10},
                {x:50,y:100},
                {x:60,y:50},
                {x:100,y:30}
            ];

            var interpolate = [
                'linear-closed', 'linear', 
                'step', 'step-before', 'step-after',
                'basis', 'basis-open', 'basis-closed',
                'bundle',
                'cardinal', 'cardinal-open', 'cardinal-closed',
                'monotone'  
            ]

            var line0 = d3.svg.line()
                .x(function(d) {return d.x;})
                .y(function(d) {return d.y;})
                .interpolate(interpolate[0])
                .tension(2);

            var line1 = d3.svg.line()
                .x(function(d) {return d.x;})
                .y(function(d) {return d.y;})
                .interpolate(interpolate[1])
                .tension(2);

            var line2 = d3.svg.line()
                .x(function(d) {return d.x;})
                .y(function(d) {return d.y;})
                .interpolate(interpolate[2])
                .tension(2);

            var line3 = d3.svg.line()
                .x(function(d) {return d.x;})
                .y(function(d) {return d.y;})
                .interpolate(interpolate[3])
                .tension(2);

            var line4 = d3.svg.line()
                .x(function(d) {return d.x;})
                .y(function(d) {return d.y;})
                .interpolate(interpolate[4])
                .tension(2);

            var line5 = d3.svg.line()
                .x(function(d) {return d.x;})
                .y(function(d) {return d.y;})
                .interpolate(interpolate[5])
                .tension(2);

            var line6 = d3.svg.line()
                .x(function(d) {return d.x;})
                .y(function(d) {return d.y;})
                .interpolate(interpolate[6])
                .tension(2);

            var line7 = d3.svg.line()
                .x(function(d) {return d.x;})
                .y(function(d) {return d.y;})
                .interpolate(interpolate[7])
                .tension(2);

            var line8 = d3.svg.line()
                .x(function(d) {return d.x;})
                .y(function(d) {return d.y;})
                .interpolate(interpolate[8])
                .tension(2);

            var line9 = d3.svg.line()
                .x(function(d) {return d.x;})
                .y(function(d) {return d.y;})
                .interpolate(interpolate[9])
                .tension(2);

            var line10 = d3.svg.line()
                .x(function(d) {return d.x;})
                .y(function(d) {return d.y;})
                .interpolate(interpolate[10])
                .tension(2);

            var line11 = d3.svg.line()
                .x(function(d) {return d.x;})
                .y(function(d) {return d.y;})
                .interpolate(interpolate[11])
                .tension(2);

            var line12 = d3.svg.line()
                .x(function(d) {return d.x;})
                .y(function(d) {return d.y;})
                .interpolate(interpolate[12])
                .tension(2);

            var line13 = d3.svg.line()
                .x(function(d) {return d.x;})
                .y(function(d) {return d.y;})
                .interpolate(interpolate[13])
                .tension(2);

            var svg = d3.select('body')
                .append('svg')
                .attr({
                    'width': '800',
                    'height': '800'
                });

            var newX = 0;
            var newY = 0;
            var chartWidth = 130;
            var chartHeight = 200;
            
            for (p=0; p<interpolate.length; p++) {

                var group = svg.append("g").attr("class","group"+p);

                group.selectAll('circle')
                    .data(data)
                    .enter()
                    .append('circle')
                    .attr('cx', function(d,i) { return d.x; } )
			        .attr('cy', function(d,i) { return d.y; } )
			        .attr('r', 4)
                    .attr('transform', 'translate('+newX+','+newY+')');

                group.append("text")
                    .attr('text-anchor','middle')
                    .attr('x',function(d,i){ return newX + 50; })
                    .attr('y', newY + 150)
                    .text(interpolate[p]);

                 group.append('path')
                    .attr({
                        'd': function(d, i) { return window['line'+p](data); },
                        'y': 0,
                        'stroke': '#000',
                        'stroke-width': '2px',
                        'fill': 'none',
                        'transform': 'translate('+newX+','+newY+')'
                    });

                //console.log('p:' + p + ' newX:' + newX + ' newY:' + newY);
                if (newX+chartWidth > 800-chartWidth) {
                    newX = 0;
                    newY += chartHeight;
                } else {
                    newX += chartWidth;
                }
            }

        </script>
    </body>
</html>